"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Document = exports.__DocContext = void 0;
const compat_1 = __importStar(require("preact/compat"));
exports.__DocContext = compat_1.createContext({ head: { current: [] } });
const Document = ({ render, styles = [], hasScripts = false, children }) => {
    const head = compat_1.useRef([]);
    const subtree = render(compat_1.default.createElement(exports.__DocContext.Provider, { value: { head } }, children), {}, { pretty: true });
    return (compat_1.default.createElement("html", null,
        compat_1.default.createElement("head", null,
            compat_1.default.createElement("meta", { charSet: "utf-8" }),
            compat_1.default.createElement("meta", { name: "viewport", content: "width=device-width" }),
            compat_1.default.createElement(compat_1.default.Fragment, null, head.current),
            styles.map((style) => (compat_1.default.createElement("style", { dangerouslySetInnerHTML: { __html: style } })))),
        compat_1.default.createElement("body", null,
            compat_1.default.createElement("div", { id: "__microsite", dangerouslySetInnerHTML: { __html: subtree } }),
            hasScripts ? (compat_1.default.createElement(compat_1.default.Fragment, null,
                compat_1.default.createElement("script", { type: "module", src: "/index.js" }),
                compat_1.default.createElement("script", Object.assign({}, { nomodule: "" }, { src: "https://unpkg.com/systemjs@2.0.0/dist/s.min.js" })),
                compat_1.default.createElement("script", Object.assign({}, { nomodule: "" }, { src: "/index.legacy.js" })))) : null)));
};
exports.Document = Document;
